include "ZeroPage.inc"

ext RowFlags_
ext VVram_

BackgroundWidth equ 32/2/2
BackgroundHeight equ 24

Char_Space equ 0
Char_Background equ 31

BG_Space equ 0
BG_CrackedFloor equ 1
BG_CrackedFloor0 equ 1
BG_CrackedFloor1 equ 2
BG_CrackedFloor2 equ 3
BG_CrackedFloor3 equ 4
BG_HardFloor equ 5
BG_Ladder equ 6
BG_Item equ 7
BG_ItemLower equ 7
BG_ItemUpper equ 8
BG_End equ 9

dseg
Background_: public Background_
    defs BackgroundWidth*BackgroundHeight

pBackground equ ZW0
pVVram equ ZW1
masked equ ZB0
sourceOffset equ ZB1
vvramOffset equ ZB2
flagOffset equ ZB3
xCount equ ZB4
yCount equ ZB5
maskBit equ ZB6
flags equ ZB7


; void SetBackground(byte x, byte y, byte c);
dseg
SetBackground_@Param0: public SetBackground_@Param0
SetBackground_x:
    defb 0
SetBackground_@Param1: public SetBackground_@Param1
SetBackground_y:
    defb 0
SetBackground_@Param2: public SetBackground_@Param2
SetBackground_c:
    defb 0
cseg
SetBackground_: public SetBackground_
    pha
        lda SetBackground_y
        asl a ;*2
        asl a ;*4
        asl a ;*8
        sta <pBackground

        lda SetBackground_x
        lsr a
        clc|adc <pBackground

        clc|adc #low Background_ | sta <pBackground
        lda #0 | adc #high Background_ | sta <pBackground+1

        ldy #0
        lda SetBackground_x
        and #1
        if eq
            lda SetBackground_c
            and #$0f
            sta <masked
            lda (<pBackground),y
            and #$f0
        else
            lda SetBackground_c
            asl a | asl a | asl a | asl a
            sta <masked
            lda (<pBackground),y
            and #$0f
        endif
        ora <masked
        sta (<pBackground),y
    pla
rts


BackgroundToVVramRowInit:
    lda #low Background_ | sta <pBackground
    lda #high Background_ | sta <pBackground+1

    lda #low VVram_ | sta <pVVram
    lda #high VVram_ | sta <pVVram+1

    lda #BackgroundHeight | sta <yCount
rts

BackgroundToVVramRow:
    ldy #0 | sty <sourceOffset | sty <vvramOffset
    lda #BackgroundWidth | sta <xCount
    do
        ldy <sourceOffset
        lda (<pBackground),y | iny
        sty <sourceOffset

        ldy <vvramOffset
        ldx #0
        do
            cmp BGTable,x
            beq BackgroundToVVramRow_hit
            inx | inx | inx | inx
        while ne | wend
        BackgroundToVVramRow_hit:
        inx
        lda BGTable,x | inx
        sta (<pVVram),y | iny
        lda BGTable,x | inx
        sta (<pVVram),y | iny
        lda BGTable,x | inx
        sta (<pVVram),y | iny
        sty <vvramOffset
        
        dec <xCount
    while ne | wend
rts

BackgroundToVVramRowNext:
    lda <pBackground | clc|adc #BackgroundWidth | sta <pBackground
    lda <pBackground+1 | adc #0 | sta <pBackground+1

    lda <pVVram | clc|adc #BackgroundWidth*3 | sta <pVVram
    lda <pVVram+1 | adc #0 | sta <pVVram+1
rts


; void BackgroundToVVramAll();
cseg
BackgroundToVVramAll_: public BackgroundToVVramAll_
    pha
        jsr BackgroundToVVramRowInit
        do
            jsr BackgroundToVVramRow
            jsr BackgroundToVVramRowNext
            dec <yCount
        while ne | wend
    pla
rts


; void BackgroundToVVramChanged();
cseg
BackgroundToVVramChanged_: public BackgroundToVVramChanged_
    pha
        jsr BackgroundToVVramRowInit

        ldx #0 | stx <flagOffset
        lda #1 | sta <maskBit
        lda RowFlags_,x | sta <flags

        lda #BackgroundHeight | sta <yCount
        do
            lda <flags
            and <maskBit
            if ne
                jsr BackgroundToVVramRow
            endif
            jsr BackgroundToVVramRowNext
            asl <maskBit
            if eq
                ldx <flagOffset
                inx
                stx <flagOffset
                lda #1 | sta <maskBit
                lda RowFlags_,x | sta <flags
            endif
            dec <yCount
        while ne | wend
    pla
rts


BGTable:
	defb BG_Space or (BG_Space shl 4), Char_Space,Char_Space,Char_Space
	defb BG_Space or (BG_Ladder shl 4), Char_Space,Char_Background+39,Char_Background+41
	defb BG_Space or (BG_ItemLower shl 4), Char_Space,Char_Background+59,Char_Background+67
	defb BG_Ladder or (BG_Space shl 4), Char_Background+43,Char_Background+44,Char_Space
	defb BG_Ladder or (BG_Ladder shl 4), Char_Background+43,Char_Background+46,Char_Background+41
	defb BG_Ladder or (BG_ItemLower shl 4), Char_Background+43,Char_Background+63,Char_Background+67
	defb BG_ItemLower or (BG_Space shl 4), Char_Background+61,Char_Background+64,Char_Space
	defb BG_ItemLower or (BG_Ladder shl 4), Char_Background+61,Char_Background+66,Char_Background+41
	defb BG_ItemLower or (BG_ItemLower shl 4), Char_Background+61,Char_Background+65,Char_Background+67
	defb BG_Space or (BG_ItemUpper shl 4), Char_Space,Char_Background+54,Char_Background+58
	defb BG_Ladder or (BG_ItemUpper shl 4), Char_Background+43,Char_Background+62,Char_Background+58
	defb BG_ItemUpper or (BG_Space shl 4), Char_Background+57,Char_Background+55,Char_Space
	defb BG_ItemUpper or (BG_Ladder shl 4), Char_Background+57,Char_Background+60,Char_Background+41
	defb BG_ItemUpper or (BG_ItemUpper shl 4), Char_Background+57,Char_Background+56,Char_Background+58
	defb BG_Space or (BG_CrackedFloor0 shl 4), Char_Space,Char_Background+11,Char_Background+26
	defb BG_Space or (BG_CrackedFloor1 shl 4), Char_Space,Char_Background+4,Char_Background+2
	defb BG_Space or (BG_CrackedFloor2 shl 4), Char_Space,Char_Background+3,Char_Background+0
	defb BG_Space or (BG_CrackedFloor3 shl 4), Char_Space,Char_Background+9,Char_Background+8
	defb BG_Space or (BG_HardFloor shl 4), Char_Space,Char_Background+13,Char_Background+38
	defb BG_Ladder or (BG_CrackedFloor0 shl 4), Char_Background+43,Char_Background+49,Char_Background+26
	defb BG_Ladder or (BG_CrackedFloor1 shl 4), Char_Background+43,Char_Background+50,Char_Background+2
	defb BG_Ladder or (BG_CrackedFloor2 shl 4), Char_Background+43,Char_Background+48,Char_Background+0
	defb BG_Ladder or (BG_CrackedFloor3 shl 4), Char_Background+43,Char_Background+47,Char_Background+8
	defb BG_Ladder or (BG_HardFloor shl 4), Char_Background+43,Char_Background+51,Char_Background+38
	defb BG_CrackedFloor0 or (BG_Space shl 4), Char_Background+25,Char_Background+27,Char_Space
	defb BG_CrackedFloor0 or (BG_Ladder shl 4), Char_Background+25,Char_Background+52,Char_Background+41
	defb BG_CrackedFloor0 or (BG_CrackedFloor0 shl 4), Char_Background+25,Char_Background+30,Char_Background+26
	defb BG_CrackedFloor0 or (BG_CrackedFloor1 shl 4), Char_Background+25,Char_Background+31,Char_Background+2
	defb BG_CrackedFloor0 or (BG_CrackedFloor2 shl 4), Char_Background+25,Char_Background+29,Char_Background+0
	defb BG_CrackedFloor0 or (BG_CrackedFloor3 shl 4), Char_Background+25,Char_Background+28,Char_Background+8
	defb BG_CrackedFloor0 or (BG_HardFloor shl 4), Char_Background+25,Char_Background+32,Char_Background+38
	defb BG_CrackedFloor1 or (BG_Space shl 4), Char_Background+7,Char_Background+5,Char_Space
	defb BG_CrackedFloor1 or (BG_Ladder shl 4), Char_Background+7,Char_Background+45,Char_Background+41
	defb BG_CrackedFloor1 or (BG_CrackedFloor0 shl 4), Char_Background+7,Char_Background+22,Char_Background+26
	defb BG_CrackedFloor1 or (BG_CrackedFloor3 shl 4), Char_Background+7,Char_Background+21,Char_Background+8
	defb BG_CrackedFloor1 or (BG_HardFloor shl 4), Char_Background+7,Char_Background+23,Char_Background+38
	defb BG_CrackedFloor2 or (BG_Space shl 4), Char_Background+6,Char_Background+1,Char_Space
	defb BG_CrackedFloor2 or (BG_Ladder shl 4), Char_Background+6,Char_Background+40,Char_Background+41
	defb BG_CrackedFloor2 or (BG_CrackedFloor0 shl 4), Char_Background+6,Char_Background+12,Char_Background+26
	defb BG_CrackedFloor2 or (BG_CrackedFloor3 shl 4), Char_Background+6,Char_Background+10,Char_Background+8
	defb BG_CrackedFloor2 or (BG_HardFloor shl 4), Char_Background+6,Char_Background+14,Char_Background+38
	defb BG_CrackedFloor3 or (BG_Space shl 4), Char_Background+24,Char_Background+15,Char_Space
	defb BG_CrackedFloor3 or (BG_Ladder shl 4), Char_Background+24,Char_Background+42,Char_Background+41
	defb BG_CrackedFloor3 or (BG_CrackedFloor0 shl 4), Char_Background+24,Char_Background+18,Char_Background+26
	defb BG_CrackedFloor3 or (BG_CrackedFloor1 shl 4), Char_Background+24,Char_Background+19,Char_Background+2
	defb BG_CrackedFloor3 or (BG_CrackedFloor2 shl 4), Char_Background+24,Char_Background+17,Char_Background+0
	defb BG_CrackedFloor3 or (BG_CrackedFloor3 shl 4), Char_Background+24,Char_Background+16,Char_Background+8
	defb BG_CrackedFloor3 or (BG_HardFloor shl 4), Char_Background+24,Char_Background+20,Char_Background+38
	defb BG_HardFloor or (BG_Space shl 4), Char_Background+38,Char_Background+33,Char_Space
	defb BG_HardFloor or (BG_Ladder shl 4), Char_Background+38,Char_Background+53,Char_Background+41
	defb BG_HardFloor or (BG_CrackedFloor0 shl 4), Char_Background+38,Char_Background+36,Char_Background+26
	defb BG_HardFloor or (BG_CrackedFloor1 shl 4), Char_Background+38,Char_Background+37,Char_Background+2
	defb BG_HardFloor or (BG_CrackedFloor2 shl 4), Char_Background+38,Char_Background+35,Char_Background+0
	defb BG_HardFloor or (BG_CrackedFloor3 shl 4), Char_Background+38,Char_Background+34,Char_Background+8
	defb BG_HardFloor or (BG_HardFloor shl 4), Char_Background+38,Char_Background+38,Char_Background+38
