include 'ZeroPage.inc'

tempo equ 160 / 5
tempo_denom equ 600  / 2 / 5

count equ 3
Channel_Ptr equ 0
Channel_Start equ Channel_Ptr+2
Channel_Len equ Channel_Start+2
unitSize equ Channel_Len+1

Port equ $900a


    dseg
;Wait defb 0
Channels defs unitSize*count
time: defb 0
port_offset defb 0
temp_ix defw 0


    cseg  
InitSound_: public InitSound_
    ldx #0
    ldy #count
    do
        lda #0
        sta Channels+Channel_Ptr,x
        sta Channels+Channel_Ptr+1,x
        txa | clc | adc #unitSize | tax
        dey
    while ne | wend
    lda #0
    sta time
rts


cseg
SoundHandler: public SoundHandler
    ;ldx Wait
    ;if ne
    ;    dex
    ;    stx Wait
    ;endif

    lda <ZW0+0 | pha
    lda <ZW0+1 | pha
        lda time
        sec | sbc #tempo
        sta time
        if cc
            ldx #0
            ldy #0
            sty port_offset ; port offset
            do
                lda Channels+Channel_Ptr,x
                ora Channels+Channel_Ptr+1,x
                if ne
                    dec Channels+Channel_Len,x
                    if eq
                        continue:
                        lda Channels+Channel_Ptr,x
                        sta <ZW0+0
                        lda Channels+Channel_Ptr+1,x
                        sta <ZW0+1
                        ldy #0 | lda (<ZW0),y
                        cmp #0
                        if eq
                            ; end
                            sta Channels+Channel_Ptr,x
                            sta Channels+Channel_Ptr+1,x
                            ldy port_offset ; port offset
                            sta Port,y
                            jmp next
                        endif
                        cmp #$ff
                        if eq
                            ; repeat
                            lda Channels+Channel_Start,x
                            sta Channels+Channel_Ptr,x
                            lda Channels+Channel_Start+1,x
                            sta Channels+Channel_Ptr+1,x
                            jmp continue
                        endif
                        sta Channels+Channel_Len,x
                        ldy #1 | lda (<ZW0),y
                        if ne
                            sec | sbc #1
                            tay
                            lda cycles, y
                        else
                            lda #0
                        endif
                        ldy port_offset ; port offset
                        sta Port,y

                        lda Channels+Channel_Ptr,x | clc | adc #2 | sta Channels+Channel_Ptr,x
                        lda Channels+Channel_Ptr+1,x | adc #0 | sta Channels+Channel_Ptr+1,x
                    endif
                    lda Channels+Channel_Len,x
                    if eq
                        lda #0
                        ldy port_offset ; port offset
                        sta Port,y
                    endif
                endif
                next:
                txa | clc | adc #unitSize | tax
                ldy port_offset ; port offset
                iny 
                sty port_offset ; port offset
                cpy #count
            while ne | wend
            lda time
            clc | adc #tempo_denom
            sta time
        endif
    pla | sta <ZW0+1
    pla | sta <ZW0+0
rts


Melody:
    sei
        stx Channels+unitSize*1+Channel_Ptr
        sty Channels+unitSize*1+Channel_Ptr+1
        lda #1
        sta Channels+unitSize*1+Channel_Len
    cli
rts

MelodyWait:
    sei
        stx Channels+unitSize*2+Channel_Ptr
        sty Channels+unitSize*2+Channel_Ptr+1
        lda #1
        sta Channels+unitSize*2+Channel_Len
    cli
    do
        lda Channels+unitSize*2+Channel_Ptr
        ora Channels+unitSize*2+Channel_Ptr+1
    while ne | wend
rts

; void Sound_Loose();
loose_notes:
    defb 1,C4, 0
Sound_Loose_: public Sound_Loose_
    ldx #low loose_notes
    ldy #high loose_notes
jmp MelodyWait


; void Sound_Hit();
hit_notes:
    defb 1,F4, 1,G4, 1,A4, 1,B4, 1,C5, 1,D5, 1,E5, 1,F5
    defb 0 
Sound_Hit_: public Sound_Hit_
    ldx #low hit_notes
    ldy #high hit_notes
jmp Melody


; void Sound_Beep();
beep_notes:
    defb 1,A4, 0
Sound_Beep_: public Sound_Beep_
    ldx #low beep_notes
    ldy #high beep_notes
jmp MelodyWait


; ; void Sound_Item();
; item_notes:
;     defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
; Sound_Item_: public Sound_Item_
;     ldx #low item_notes
;     ldy #high item_notes
; jmp Melody


; void Sound_Start();
start_notes:
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 47,C5,1,0
    defb 0
Sound_Start_: public Sound_Start_
    ldx #low start_notes
    ldy #high start_notes
jmp MelodyWait


; void Sound_Clear();
clear_notes:
	defb 5,C4,1,0, 5,E4,1,0, 5,G4,1,0, 5,D4,1,0
	defb 5,F4,1,0, 5,A4,1,0, 5,E4,1,0, 5,G4,1,0
	defb 5,B4,1,0, 17,C5,1,0
    defb 0
Sound_Clear_: public Sound_Clear_
    ldx #low clear_notes
    ldy #high clear_notes
jmp MelodyWait


; void Sound_GameOver();
over_notes: 
	defb 5,C5,1,0, 5,C5,1,0, 5,G4,1,0, 5,G4,1,0
	defb 5,A4,1,0, 5,A4,1,0, 5,B4,1,0, 5,B4,1,0
	defb 35,C5,1,0
	defb 12,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    ldx #low over_notes
    ldy #high over_notes
jmp MelodyWait


BGM_2:
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 6,0, 5,C5,1,0
	defb 5,C5,1,0, 5,C5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,F5,1,0, 5,F5,1,0, 5,E5,1,0
	defb 5,C5,1,0, 11,C5,1,0, 11,D5,1,0
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 11,F5,1,0
	defb 11,F5,1,0, 11,E5,1,0
	defb 11,E5,1,0, 11,D5,1,0
	defb 5,D5,1,0, 11,E5,1,0, 5,E5,1,0
	defb 5,D5,1,0, 5,C5,1,0, 11,C5,1,0
	defb 11,C5,1,0, 5,D5,1,0, 11,D5,1,0
	defb 17,C5,1,0, 36,0
    defb $ff

BGM_0:
	defb 5,C4,1,0, 12,0, 17,E4,1,0
	defb 5,G4,1,0, 6,0, 5,A4,1,0, 12,0
	defb 17,C4,1,0, 5,E4,1,0
	defb 6,0, 5,D4,1,0, 12,0
	defb 17,F4,1,0, 5,A4,1,0
	defb 6,0, 5,G4,1,0, 12,0
	defb 17,B4,1,0, 5,D4,1,0
	defb 6,0, 5,C4,1,0, 12,0
	defb 17,E4,1,0, 5,G4,1,0
	defb 6,0, 5,A4,1,0, 12,0
	defb 17,C4,1,0, 5,E4,1,0
	defb 6,0, 5,F4,1,0, 12,0
	defb 17,A4,1,0, 5,C4,1,0
	defb 6,0, 5,D4,1,0, 12,0
	defb 17,E4,1,0, 5,A4,1,0
	defb 6,0, 5,F4,1,0, 12,0
	defb 5,F4,1,0, 5,G4,1,0, 6,0, 5,B4,1,0
	defb 5,D4,1,0, 5,C4,1,0, 12,0
	defb 17,E4,1,0, 5,G4,1,0
	defb 6,0
    defb $ff

; void StartBGM();
StartBGM_: public StartBGM_
    sei
        lda #low BGM_0
        sta Channels+unitSize*0+Channel_Start
        sta Channels+unitSize*0+Channel_Ptr
        lda #high BGM_0
        sta Channels+unitSize*0+Channel_Start+1
        sta Channels+unitSize*0+Channel_Ptr+1
        lda #1
        sta Channels+unitSize*0+Channel_Len
        
        lda #low BGM_2
        sta Channels+unitSize*2+Channel_Start
        sta Channels+unitSize*2+Channel_Ptr
        lda #high BGM_2
        sta Channels+unitSize*2+Channel_Start+1
        sta Channels+unitSize*2+Channel_Ptr+1
        lda #1
        sta Channels+unitSize*2+Channel_Len
    cli
rts


; void StopBGM();
StopBGM_: public StopBGM_
    sei
        lda #0
        sta Channels+unitSize*0+Channel_Ptr
        sta Channels+unitSize*0+Channel_Ptr+1
        sta Channels+unitSize*2+Channel_Ptr
        sta Channels+unitSize*2+Channel_Ptr+1
        ldy #0
        do
            sta Port,y
            iny
            cpy #3
        while ne | wend
    cli
rts


C4 equ 1
C4S equ 2
D4 equ 3
D4S equ 4
E4 equ 5
F4 equ 6
F4S equ 7
G4 equ 8
G4S equ 9
A4 equ 10
A4S equ 11
B4 equ 12
C5 equ 13
C5S equ 14
D5 equ 15
D5S equ 16
E5 equ 17
F5 equ 18

cycles:
defb 193 ; C4
defb 197 ; C4S
defb 200 ; D4
defb 203 ; D4S
defb 206 ; E4
defb 209 ; F4
defb 211 ; F4S
defb 214 ; G4
defb 216 ; G4S
defb 218 ; A4
defb 220 ; A4S
defb 222 ; B4
defb 224 ; C5
defb 226 ; C5S
defb 227 ; D5
defb 229 ; D5S
defb 230 ; E5
defb 232 ; F5
