#include "Movable.h"
#include "Sprite.h"
#include "VVram.h"
#include "Chars.h"
#include "Vram.h"
#include "Main.h"
#include "Stage.h"

extern byte[] Chars;

constexpr byte InvalidPattern = 0xff;
struct Sprite {
    byte x, y;
    byte pattern;
    byte oldX, oldY;
    byte oldPattern;
};
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->pattern = InvalidPattern;
        p->oldPattern = InvalidPattern;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte pattern)
{
    ptr<Sprite> p;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    p->pattern = pattern;
}


void HideSprite(byte sprite) 
{
    ptr<Sprite> p;
    p = Sprites + sprite;
    p->pattern = InvalidPattern;
}


void EraseSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->oldPattern != InvalidPattern && (
            p->oldX != p->x || 
            p->oldY != p->y ||
            p->pattern == InvalidPattern
        )) {
            SetRowFlags(p->oldY, 3);
        }
    }
}


void DrawSprites()
{
    ptr<Sprite> p;
    byte c;
    c = Char_Sprite;
    for (p : Sprites) {
        if (p->pattern != InvalidPattern) {
            ptr<byte> pVVram, pPattern;
            byte x, xMod, y, iy;
            y = p->y;
            SetRowFlags(y, 3);
            x = p->x;
            xMod = x & 3;
            pPattern = Chars + ((word)p->pattern << 3); 
            pVVram = VVramPtr(x, y);
            repeat (2) {
                if (y < VVramHeight) {
                    VLocate(pVVram, xMod, c);
                    repeat (2) {
                        VPut(pPattern);
                        pPattern += PatternSize;
                    }
                }
                c += 3;
                ++y;
                pVVram += VVramWidth;
            }
        }
        else {
            c += 6;
        }
        p->oldX = p->x;
        p->oldY = p->y;
        p->oldPattern = p->pattern;
    }
}
