include "Vram.inc"
include "ZeroPage.inc"

ext InitVram_
ext InitSound_, SoundHandler
ext Main_


dseg
RegSave0 defb 0
RegSave2 defb 0
RegSave3 defb 0
RegSave5 defb 0
RegSaveE defb 0
RegSaveF defb 0

IntSave defw 0 
TimerCount defw 0

cseg
    lda $9000   ; horizontal centering
    sta RegSave0
    and #$08
    ora #$02
    sta $9000

    lda $9002   ; set # of columns, bit 7 is part of screen address
    sta RegSave2
    lda #VramWidth
    sta $9002

    lda $9003   ; set # of rows
    sta RegSave3
    lda #(VramHeight shl 1)
    sta $9003

    lda $9005   ; bits 0-3 start of character memory / bits 4-7 is rest of video address
    sta RegSave5
    lda #$cd
    sta $9005

    lda $900e   ; bit 0-3 sets volume of all sound / bits 4-7 are auxiliary color information
    sta RegSaveE
    lda #$07
    sta $900E

    lda $900f   ; Screen and border color register
    sta RegSaveF
    lda #$08
    sta $900f

    jsr InitVram_
    jsr InitSound_

    sei
        lda #0 | sta TimerCount
        lda $0314
        sta IntSave
        lda $0315
        sta IntSave+1
        lda #low Handler
        sta $0314
        lda #high Handler
        sta $0315
    cli

    jsr Main_

    sei
        lda IntSave
        sta $0314
        lda IntSave+1
        sta $0315
    cli

    lda RegSave0
    sta $9000
    lda RegSave2
    sta $9002
    lda RegSave3
    sta $9003
    lda RegSave5
    sta $9005
    lda RegSaveE
    sta $900e
    lda RegSaveF
    sta $900f
rts


Handler:
    inc TimerCount
    jsr SoundHandler
jmp (IntSave)


; void WaitTimer(byte t);
dseg
WaitTimer_@Param0: public WaitTimer_@Param0
    defb 0
cseg
WaitTimer_: public WaitTimer_
    pha
        do
            lda TimerCount
            cmp WaitTimer_@Param0
        while cc | wend
        sei
            lda #0 | sta TimerCount
        cli
    pla
rts