#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern byte[] Chars;

ptr<byte> pCurrentVram;
bool CharShift;
ptr<byte> pCurrentPattern;
byte TargetChar;

byte[256] CharColors;

static const byte[] ColorSource = {
	Char_Background0, 54, 3,
	Char_Background2, 14, 7,
	Char_Monster, 24, 2,
    0xff
};

static void SetColors(ptr<byte> pSource)
{
    ptr<byte> pColor;
    pColor = CharColors;
    repeat (0) {
        *pColor = 1;
        ++pColor;
    }
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
}

void InitVram()
{
    SetColors(ColorSource);
    FillMemory(PatternRam, PatternSize, 0x00); // Space
    CopyMemory(
        PatternRam + Char_Background * PatternSize,
        Chars + Pattern_Background * PatternSize, 
        PatternSize * (Pattern_Man - Pattern_Background)
    );
}


void ClearScreen()
{
    FillMemory(Vram, VramWidth * VramHeight, Char_Space);
    FillMemory(ColorMap, VramWidth * VramHeight, 1);
}

void Locate(ptr<byte> pVram) 
{
    pCurrentVram = pVram;
    CharShift = false;
}

void CurrentChar(byte c)
{
    TargetChar = c;
    pCurrentPattern = PatternRam + (((word)c) << 3);
}
