constexpr byte VramWidth = 24;
constexpr byte VramHeight = 24;

constexpr ptr<byte> Vram = (ptr<byte>)0x1000;
constexpr ptr<byte> PatternRam = (ptr<byte>)0x1400;
constexpr ptr<byte> ColorMap = (ptr<byte>)0x9400;
constexpr byte VramRowSize = VramWidth;
constexpr byte PatternSize = 8;

extern byte[] CharColors;

extern void VVramToVramAll();
extern void VVramToVramChanged();

extern void PrintC(byte c);
extern void EndPrint();

extern void VLocate(ptr<byte> pDestination, byte xMod, byte c);
extern void VPut(ptr<byte> pPattern);

extern void InitVram();
extern void ClearScreen();
extern void Locate(ptr<byte> pVram);
extern void CurrentChar(byte c);
