include 'Zeropage.inc'
include 'Vram.inc'
include 'VVram.inc'

ext CharColors_
ext VVram_, RowFlags_

VramTop equ Vram+VramWidth*2
ColorTop equ ColorMap+VramWidth*2
VVramTop equ VVram_+VVramWidth

pVVram equ ZW0
pVram equ ZW1
pColor equ ZW2
yCount equ ZB0
flagIndex equ ZB1
maskBit equ ZB2
flags equ ZB3

cseg

cseg
VVramToVramRow:
    ldy #0
    do
        lda (<pVVram),y
        sta (<pVram),y
        tax
        lda CharColors_,x
        sta (<pColor),y
        iny
        cpy #VVramWidth
    while ne | wend
NextRow:
    lda <pVVram | clc | adc #VVramWidth | sta <pVVram
    lda <pVVram+1 | adc #0 | sta <pVVram+1

    lda <pVram | clc | adc #VramWidth | sta <pVram
    lda <pVram+1 | adc #0 | sta <pVram+1
    lda <pColor | clc | adc #VramWidth | sta <pColor
    lda <pColor+1 | adc #0 | sta <pColor+1
rts


; void VVramToVramAll();
cseg
VVramToVramAll_: public VVramToVramAll_
    lda #low VVramTop | sta <pVVram
    lda #high VVramTop | sta <pVVram+1

    lda #low VramTop | sta <pVram
    lda #high VramTop | sta <pVram+1
    lda #low ColorTop | sta <pColor
    lda #high ColorTop | sta <pColor+1

    lda #VVramHeight-2
    sta <yCount
    do
        jsr VVramToVramRow
        dec <yCount
    while ne | wend
rts

; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    lda #low VVramTop | sta <pVVram
    lda #high VVramTop | sta <pVVram+1

    lda #low VramTop | sta <pVram
    lda #high VramTop | sta <pVram+1
    lda #low ColorTop | sta <pColor
    lda #high ColorTop | sta <pColor+1

    ldx #0 | stx <flagIndex
    lda #2 | sta <maskBit
    lda RowFlags_,x | sta <flags

    lda #VVramHeight-2
    sta <yCount
    do
        lda <flags
        and <maskBit
        if ne
            jsr VVramToVramRow
        else
            jsr NextRow
        endif
        asl <maskBit
        if eq
            ldx <flagIndex
            inx
            stx <flagIndex
            lda #1 | sta <maskBit
            lda RowFlags_,x | sta <flags
        endif
        dec <yCount
    while ne | wend

    ldx #0
    lda #0
    do
        sta RowFlags_,x
        inx
        cpx #3
    while ne | wend
rts