include 'Zeropage.inc'
include 'Vram.inc'

ext Ascii_, Chars_
ext pCurrentPattern_, CharShift_, pCurrentVram_, TargetChar_

AsciiColor equ 1


NextChar:
    lda pCurrentPattern_ | clc | adc #low CharHeight | sta pCurrentPattern_
    lda pCurrentPattern_+1 | adc #high CharHeight | sta pCurrentPattern_+1

    inc TargetChar_
rts

; void PrintC(byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_c:
    defb 0
pSourcePattern equ ZW0
sourceIndex equ ZB0
pDestination equ ZW1
destinationIndex equ ZB1
counter equ ZB2

    cseg
PrintC_: public PrintC_
    lda PrintC_c | clc | adc #(-' ') | sta <pSourcePattern
    lda #0 | sta <pSourcePattern+1
    
    asl <pSourcePattern | rol <pSourcePattern+1 ; *2
    asl <pSourcePattern | rol <pSourcePattern+1 ; *4
    
    lda <pSourcePattern | clc | adc #low Ascii_ | sta <pSourcePattern
    lda <pSourcePattern+1 | adc #high Ascii_ | sta <pSourcePattern+1

    lda pCurrentPattern_ | sta <pDestination
    lda pCurrentPattern_+1 | sta <pDestination+1

    lda #0
    sta <sourceIndex
    sta <destinationIndex

    lda #CharHeight/2 | sta <counter
    lda CharShift_
    if eq
        do 
            ldy <sourceIndex
            lda (<pSourcePattern),y | iny
            sty <sourceIndex

            ldy <destinationIndex
            tax
                and #$f0
                sta (<pDestination),y | iny
            txa
            asl a | asl a | asl a | asl a
            sta (<pDestination),y | iny
            sty <destinationIndex
            
            dec <counter
        while ne | wend

        ldx #0

        lda pCurrentVram_ | sta <pDestination
        lda pCurrentVram_+1 | sta <pDestination+1
        lda TargetChar_ | sta (<pDestination,x)

        lda <pDestination+1 | clc | adc #high(ColorMap-Vram) | sta <pDestination+1
        lda #AsciiColor | sta (<pDestination,x)
    else
        do 
            ldy <sourceIndex
            lda (<pSourcePattern),y | iny
            sty <sourceIndex
           
            ldy <destinationIndex
            tax
                lsr a | lsr a | lsr a | lsr a
                ora (<pDestination),y
                sta (<pDestination),y | iny
            txa
            and #$0f
            ora (<pDestination),y
            sta (<pDestination),y | iny
            sty <destinationIndex

            dec <counter
        while ne | wend

        jsr NextChar

        lda pCurrentVram_ | clc | adc #1 | sta pCurrentVram_
        lda pCurrentVram_+1 | adc #0 | sta pCurrentVram_+1
    endif

    lda CharShift_
    eor #1
    sta CharShift_
rts


; void EndPrint();
cseg
EndPrint_: public EndPrint_
    lda CharShift_
    if ne
        jsr NextChar
        lda #0
        sta CharShift_
    endif
rts