include 'Zeropage.inc'
include 'Vram.inc'

cseg
PatternRamAddress:
    sta 0,x
    lda #0 | sta 1,x
    asl 0,x | rol 1,x ; *2
    asl 0,x | rol 1,x ; *4
    asl 0,x | rol 1,x ; *8
    lda 0,x | clc | adc #low(PatternRam) | sta 0,x
    lda 1,x | adc #high(PatternRam) | sta 1,x
rts

zseg
pVram defw 0
pDestionationPattern defw 0
leftMask defb 0
rightMask defb 0
dseg
shiftCount defb 0
vramOffset defb 0
char defb 0

; void VLocate(ptr<byte> pDestination, byte xMod, byte c);
dseg
VLocate_@Param0: public VLocate_@Param0
VLocate_pDestination:
    defw 0
VLocate_@Param1: public VLocate_@Param1
VLocate_xMod:
    defb 0
VLocate_@Param2: public VLocate_@Param2
VLocate_c:
    defb 0
cseg
VLocate_: public VLocate_
    pha
        lda VLocate_pDestination | sta pVram
        lda VLocate_pDestination+1 | sta pVram+1

        lda #0 | sta vramOffset
        lda #$00 | sta <leftMask
        lda #$fc | sta <rightMask

        lda VLocate_xMod
        and #3
        asl a   ;*2
        sta shiftCount
        if ne
            tax
            do
                lda <leftMask
                asl a
                ora #$01
                sta <leftMask
                asl <rightMask
                dex
            while ne | wend
        endif

        lda VLocate_c
        sta char
        ldx #pDestionationPattern
        jsr PatternRamAddress
    pla
rts


; void VPut(ptr<byte> pSource);
dseg

VPut_@Param0: public VPut_@Param0
VPut_pSource:
    defw 0
    
pSourcePattern equ ZW0
existingPatternMask equ ZB0
sourceShiftCount equ ZB1
pExsitingPattern equ ZW1


cseg
VPut_: public VPut_
    lda VPut_pSource | sta <pSourcePattern
    lda VPut_pSource+1 | sta <pSourcePattern+1

    lda <leftMask
    if ne
        eor #$ff
        sta <existingPatternMask
        lda #8 | sec | sbc shiftCount | sta <sourceShiftCount
        
        ldy vramOffset
        lda (<pVram),y
        ldx #pExsitingPattern | jsr PatternRamAddress
        ldy #0
        do
            lda (<pExsitingPattern),y
            and <existingPatternMask
            sta (<pDestionationPattern),y
            
            lda (<pSourcePattern),y
            ldx <sourceShiftCount
            do
                lsr a
                dex
            while ne | wend                    

            and <leftMask
            ora (<pDestionationPattern),y
            sta (<pDestionationPattern),y
            iny
            cpy #8
        while ne | wend

        lda char
        ldy vramOffset
        sta (<pVram),y
        inc char
        iny | sty vramOffset

        lda <pDestionationPattern | clc | adc #8 | sta <pDestionationPattern
        lda <pDestionationPattern+1 | adc #0 | sta <pDestionationPattern+1
    endif

    lda <rightMask
    if ne
        eor #$ff
        sta <existingPatternMask

        ldy vramOffset
        lda (<pVram),y
        ldx #pExsitingPattern | jsr PatternRamAddress

        ldy #0
        do
            lda (<pExsitingPattern),y
            and <existingPatternMask
            sta (<pDestionationPattern),y

            lda (<pSourcePattern),y
            ldx shiftCount
            if ne
                do
                    asl a
                    dex
                while ne | wend
            endif

            and <rightMask
            ora (<pDestionationPattern),y
            sta (<pDestionationPattern),y
            iny
            cpy #8
        while ne | wend

        lda char
        ldy vramOffset
        sta (<pVram),y
    endif

    lda shiftCount
    clc | adc #2 | and #7
    sta shiftCount

    lda <leftMask
    asl a | asl a
    ora #$03
    cmp #$ff
    if eq
        lda #0
    endif
    sta <leftMask

    lda <rightMask
    if ne
        asl a | asl a
    else
        lda #$fc
    endif
    sta <rightMask
rts
